
package net.mcreator.skiesofender.enchantment;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.item.ItemStack;
import net.minecraft.inventory.EquipmentSlotType;
import net.minecraft.enchantment.Enchantments;
import net.minecraft.enchantment.EnchantmentType;
import net.minecraft.enchantment.Enchantment;

import net.mcreator.skiesofender.item.PitchforkItem;
import net.mcreator.skiesofender.SkiesOfEnderModElements;

@SkiesOfEnderModElements.ModElement.Tag
public class SharpeningEnchantment extends SkiesOfEnderModElements.ModElement {
	@ObjectHolder("skies_of_ender:sharpening")
	public static final Enchantment enchantment = null;
	public SharpeningEnchantment(SkiesOfEnderModElements instance) {
		super(instance, 34);
	}

	@Override
	public void initElements() {
		elements.enchantments.add(() -> new CustomEnchantment(EquipmentSlotType.MAINHAND).setRegistryName("sharpening"));
	}
	public static class CustomEnchantment extends Enchantment {
		public CustomEnchantment(EquipmentSlotType... slots) {
			super(Enchantment.Rarity.COMMON, EnchantmentType.BREAKABLE, slots);
		}

		@Override
		public int getMinLevel() {
			return 1;
		}

		@Override
		public int getMaxLevel() {
			return 3;
		}

		@Override
		protected boolean canApplyTogether(Enchantment ench) {
			if (ench == HasteEnchantment.enchantment)
				return true;
			if (ench == SlowingEnchantment.enchantment)
				return true;
			if (ench == Enchantments.MENDING)
				return true;
			if (ench == Enchantments.UNBREAKING)
				return true;
			return false;
		}

		@Override
		public boolean canApplyAtEnchantingTable(ItemStack stack) {
			if (stack.getItem() == new ItemStack(PitchforkItem.block, (int) (1)).getItem())
				return true;
			return false;
		}

		@Override
		public boolean isTreasureEnchantment() {
			return false;
		}

		@Override
		public boolean isCurse() {
			return false;
		}

		@Override
		public boolean isAllowedOnBooks() {
			return true;
		}
	}
}
